import { type SaleTerms } from './types';
import { type FilterOperator, type MintActionParams } from '@rabbitholegg/questdk-plugin-utils';
import { type Address, type PublicClient } from 'viem';
export declare function getFixedPriceData(client: PublicClient, address: Address, contractAddress: Address): Promise<{
    seller: `0x${string}`;
    actionFee: bigint;
    projectFee: bigint;
}>;
export declare function getDutchAuctionData(client: PublicClient, address: Address, contractAddress: Address): Promise<{
    seller: `0x${string}`;
    actionFee: bigint;
    projectFee: bigint;
}>;
export declare function calculateFees(pricingInfo: {
    actionFee: bigint;
    projectFee: bigint;
}, quantity: bigint): {
    actionFee: bigint;
    projectFee: bigint;
};
export declare function getSaleTermsId(mint: MintActionParams, multiTokenAddress: Address): Promise<bigint | null>;
export declare function getFixedPriceSaleTerms(client: PublicClient, salesTermId: bigint, multiTokenAddress: Address): Promise<SaleTerms>;
export declare function getContractType(client: PublicClient, contractAddress: Address): Promise<'1155' | '721' | null>;
export declare function formatAmount(amount: FilterOperator | undefined): string | number | bigint | {
    $and?: FilterOperator[] | undefined;
} | {
    $or?: FilterOperator[] | undefined;
} | {
    $gt?: bigint | undefined;
} | {
    $gte?: bigint | undefined;
} | {
    $lt?: bigint | undefined;
} | {
    $lte?: bigint | undefined;
} | {
    $some?: FilterOperator[] | undefined;
} | {
    $first?: FilterOperator | undefined;
} | {
    $last?: FilterOperator | undefined;
} | {
    $nth?: import("@rabbitholegg/questdk-plugin-utils").NthFilter | undefined;
} | import("@rabbitholegg/questdk-plugin-utils").StringOperator | {
    $gte: FilterOperator;
} | undefined;
export declare function getMintAmount(amount: FilterOperator | undefined): bigint;
//# sourceMappingURL=utils.d.ts.map